<?

class Builder extends Object
{
	static $file_permissions = 0755;
	
	static function set_file_permissions($octet)
	{
		self::$file_permissions = $octet;
	}
}



class Builder_Controller extends Controller
{
	public function index()
	{
		if(!Director::isDev())
			Director::redirectBack();
    	elseif(!Permission::check("ADMIN")) {
			Security::permissionFailure($this,
				"You must be an administrator to run the builder."
			);
    	}

		$p = Director::urlParams();
		if(!isset($p['ClassName']))
			Director::redirectBack();

		// Define variables
		$className = $p['ClassName'];
		$parentClass = isset($p['ParentClass']) ? $p['ParentClass'] : 'Page';
		$startingTemplate = isset($p['StartingTemplate']) ? $p['StartingTemplate'] : 'Page';
		$project_dir = SSViewer::current_theme() ? 'themes/'.SSViewer::current_theme() : 'mysite';
		$starting_template_path = Director::baseFolder() . "/$project_dir/templates/Layout/{$startingTemplate}.ss";
		$new_template_path = Director::baseFolder() . "/$project_dir/templates/Layout/{$className}.ss";
		
		// Get the PHP "template" to work with
		$stock_php = Director::baseFolder() . '/builder/templates/ClassTemplate.txt';
		if(!is_readable($stock_php))
			user_error("Stock PHP file ClassTexmplate.txt is not readable.");
			
		$php = file_get_contents($stock_php);
		if(!$php)
			user_error("Stock PHP file ClassTemplate.txt was empty.");
		
		// Customize the PHP template
		$php = str_replace("CLASS", $className, $php);
		$php = str_replace("PARENT", $parentClass, $php);
		$new_php_file = Director::baseFolder() . '/mysite/code/' . $className . '.php';
		
		// Save the new PHP file
		if(file_exists($new_php_file))
			user_error("File $new_php_file already exists");
			
		$new_code = fopen($new_php_file,"w");
		fwrite($new_code, $php);
		chmod($new_php_file, Builder::$file_permissions);
		
		echo "Created $new_php_file successfully.<br />";

		// Copy over a new template
		if(!file_exists($starting_template_path))
			user_error("Starting template $starting_template_path doesn't exist");

		copy($starting_template_path, $new_template_path);
		chmod($new_template_path,Builder::$file_permissions);
		
		echo "Created $new_template_path successfully.<br />";
		
		sleep(1);
		Director::redirect("/db/build?flush=1");
	}
}

?>